﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Documents.RichText;
//using Infragistics.Documents.RichText.Html;
using Infragistics.Documents.RichText.Rtf;
using Infragistics.Documents.RichText.Serialization;
using Infragistics.Controls.Editors;
using Infragistics.Windows;
using System.Windows.Controls.Primitives;

namespace RTE_Sample
{
    /// <summary>
    /// Interaction logic for RTEControl.xaml
    /// </summary>
    public partial class RTEControl : UserControl
    {
        string errors = string.Empty;
        public RTEControl()
        {
            InitializeComponent();
        }

        private void RTE_Loaded(object sender, RoutedEventArgs e)
        {
            Dispatcher.BeginInvoke(new Action(() =>
            {
                var scrollBar = Utilities.GetDescendantFromType((sender as XamRichTextEditor), typeof(ScrollBar), true) as ScrollBar;
                scrollBar.ValueChanged += ScrollBar_ValueChanged;
            }));
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var document = RTE_Contact.Document;

            document.AppendText("Contact says: ", out errors, true);
            var text = RTE_Me.Document.GetTextInSpan(DocumentSpan.All);
            document.AppendText(text, out errors, false);

            RTE_Me.Document.RootNode.Body.ChildNodes.Clear();

            var paragraphs = document.GetParagraphs(DocumentSpan.All);

            if (paragraphs != null && paragraphs.Count() > 0)
                RTE_Contact.ActiveDocumentView.VerticalViewOffset = paragraphs.LastOrDefault().GetDocumentSpan().Offset;
        }

        private void ScrollBar_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if (e.NewValue == 0)
            {
                var view = RTE_Contact.ActiveDocumentView;

                if (view != null && view.VerticalViewOffset == 0)
                {
                    string documentText = view.Document.GetTextInSpan(DocumentSpan.All);
                    if (!documentText.StartsWith("Older Messages"))
                    {
                        view.Document.InsertText(0, "Older Messages", out errors);
                    }
                }
            }
        }
    }
}
